﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace BlankIt
{
    public partial class Form1 : Form
    {
        private string filename;
        //private const string pre = "blank_";
        private const string post = "_blank.png";

        private Color c_blank = Color.FromArgb(0, 0, 0, 0);
        private Bitmap back_bmp = null;

        Cursor cur_my;

        public Form1()
        {
            InitializeComponent();
            init_sub();    
        }

        private void init_sub()
        {
            this.MinimumSize = this.Size;
            numericUpDown_lx.Value = pictureBox_left.Left;
            numericUpDown_ly.Value = pictureBox_left.Top;
            numericUpDown_rx.Value = pictureBox_right.Right;
            numericUpDown_ry.Value = pictureBox_right.Bottom;

            numericUpDown_lx.Maximum = pictureBox1.Width - 1;
            numericUpDown_ly.Maximum = pictureBox1.Height - 1;
            numericUpDown_rx.Maximum = pictureBox1.Width - 1;
            numericUpDown_ry.Maximum = pictureBox1.Height - 1;

            int size = 10;
            int block = 2;
            pictureBox_left.Width = size;
            pictureBox_left.Height = size;
            pictureBox_right.Width = size;
            pictureBox_right.Height = size;
            Bitmap bmp_l = new Bitmap(size, size);
            Bitmap bmp_r = new Bitmap(size, size);
            for (int i = 0; i < size; i++)
            {
                for (int j = 0; j < size; j++)
                {
                    if (((i / block) + (j / block)) % 2 == 0)
                    {
                        bmp_l.SetPixel(i, j, Color.Yellow);
                        bmp_r.SetPixel(i, j, Color.Gray);
                    }
                    else
                    {
                        bmp_l.SetPixel(i, j, Color.Black);
                        bmp_r.SetPixel(i, j, Color.White);
                    }
                }
            }
            pictureBox_left.Image = bmp_l;
            pictureBox_right.Image = bmp_r;

            try
            {
                cur_my = new Cursor("cross_my008.cur");
            }
            catch (Exception e)
            {
                cur_my = Cursors.Cross;
            }
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Bitmap bmp = null;
            bmp = getBitmap_OpenFileDialog();

            if (null == bmp)
            {
                return;
            }
            else
            {
                pictureBox1.Width = bmp.Width;
                pictureBox1.Height = bmp.Height;
                pictureBox1.Image = bmp;
                numericUpDown_lx.Maximum = numericUpDown_rx.Maximum = bmp.Width - 1;
                numericUpDown_ly.Maximum = numericUpDown_ry.Maximum = bmp.Height - 1;
                button_modosu.Enabled = false;
                button_execute.Enabled = true;
            }
        }

        private Bitmap getBitmap_OpenFileDialog()
        {
            Bitmap bmp = null;

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Image File(*.bmp;*.jpg;*.jpeg;*.png)|*.bmp;*.jpg;*.jpeg;*.png";
            ofd.Title = "Select Image File";
            ofd.RestoreDirectory = true;

            if (ofd.ShowDialog() == DialogResult.OK)
            {   
                System.IO.FileStream stream = new System.IO.FileStream(ofd.FileName, System.IO.FileMode.Open);
                bmp = new Bitmap(stream);
                stream.Close();

                filename = ofd.FileName;
                saveToolStripMenuItem.Enabled = true;
            }

            return bmp;
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            panel2.Width = this.ClientSize.Width - panel2.Left;
            panel2.Height = this.ClientSize.Height - panel2.Top;
        }

        private void numericUpDown_lx_ValueChanged(object sender, EventArgs e)
        {
            pictureBox_left.Left = (int)numericUpDown_lx.Value
                + pictureBox1.Left;
        }

        private void numericUpDown_ly_ValueChanged(object sender, EventArgs e)
        {
            pictureBox_left.Top = (int)numericUpDown_ly.Value
                + pictureBox1.Top;
        }

        private void numericUpDown_rx_ValueChanged(object sender, EventArgs e)
        {
            pictureBox_right.Left = (int)numericUpDown_rx.Value - pictureBox_right.Width
                + pictureBox1.Left + 1;
        }

        private void numericUpDown_ry_ValueChanged(object sender, EventArgs e)
        {
            pictureBox_right.Top = (int)numericUpDown_ry.Value - pictureBox_right.Height
                + pictureBox1.Top + 1;
        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            System.Drawing.Point sp = System.Windows.Forms.Cursor.Position;
            System.Drawing.Point cp = pictureBox1.PointToClient(sp);

            if (cp.Y > numericUpDown_ly.Maximum)
            {
                return;
            }

            if (e.Button == MouseButtons.Left)
            {
                numericUpDown_lx.Value = cp.X;
                numericUpDown_ly.Value = cp.Y;
                Thread.Sleep(300);
            }
            else if (e.Button == MouseButtons.Right)
            {
                numericUpDown_rx.Value = cp.X;
                numericUpDown_ry.Value = cp.Y;
                Thread.Sleep(300);
            }
        }

        private void button_modosu_Click(object sender, EventArgs e)
        {
            if (back_bmp != null)
            {
                pictureBox1.Width = back_bmp.Width;
                pictureBox1.Height = back_bmp.Height;
                pictureBox1.Image = back_bmp;
                button_modosu.Enabled = false;
            }
        }

        private void button_execute_Click(object sender, EventArgs e)
        {
            int minX = Math.Min((int)numericUpDown_lx.Value, (int)numericUpDown_rx.Value);
            int minY = Math.Min((int)numericUpDown_ly.Value, (int)numericUpDown_ry.Value);
            int maxX = Math.Max((int)numericUpDown_lx.Value, (int)numericUpDown_rx.Value);
            int maxY = Math.Max((int)numericUpDown_ly.Value, (int)numericUpDown_ry.Value);

            if (minX == maxX) return;
            if (minY == maxY) return;

            // 元のカーソルを保持
            Cursor preCursor = Cursor.Current;
            // カーソルを待機カーソルに変更
            Cursor.Current = Cursors.WaitCursor;

            back_bmp = (Bitmap)pictureBox1.Image;
            Bitmap bmp = new Bitmap(back_bmp.Width, back_bmp.Height + maxY - minY + 1);

            for (int i = 0; i < back_bmp.Width; i++)
            {
                for (int j = 0; j < back_bmp.Height; j++)
                {
                    bmp.SetPixel(i,j,back_bmp.GetPixel(i,j));
                }
                for(int j =  back_bmp.Height; j < bmp.Height; j++)
                {
                    bmp.SetPixel(i, j, c_blank);
                }
            }

            for (int i = minX; i <= maxX; i++)
            {
                for (int j = minY; j <= maxY; j++)
                {
                    Color c = back_bmp.GetPixel(i, j);
                    bmp.SetPixel(i, j, c_blank);
                    bmp.SetPixel(i - minX, back_bmp.Height + j - minY, c);
                }
            }
            
            pictureBox1.Width = bmp.Width;
            pictureBox1.Height = bmp.Height;
            pictureBox1.Image = bmp;
            button_modosu.Enabled = true;

            // カーソルを元に戻す
            Cursor.Current = preCursor;
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog sfd = new SaveFileDialog();

            sfd.Filter = "file(*.png)|*.png";
            sfd.Title = "save";
            sfd.FileName = filename + post;

            if (sfd.ShowDialog() == DialogResult.OK)
            {
                Bitmap bmp = new Bitmap(pictureBox1.Image);

                bmp.Save(sfd.FileName, System.Drawing.Imaging.ImageFormat.MemoryBmp);
                bmp.Dispose();
            }
        }

        private void pictureBox1_MouseEnter(object sender, EventArgs e)
        {
            pictureBox1.Cursor = cur_my;
        }


    }
}
